---
comments: true
status: new
---

# 16.3 &nbsp; 术语表

表 16-1 列出了书中出现的重要术语。建议读者同时记住它们的中英文叫法，以便阅读英文文献。

<p align="center"> 表 16-1 &nbsp; 数据结构与算法的重要名词 </p>

<div class="center-table" markdown>

| 中文           | English                        | 中文           | English                     |
| -------------- | ------------------------------ | -------------- | --------------------------- |
| 算法           | algorithm                      | AVL 树         | AVL tree                    |
| 数据结构       | data structure                 | 红黑树         | red-black tree              |
| 渐近复杂度分析 | asymptotic complexity analysis | 层序遍历       | level-order traversal       |
| 时间复杂度     | time complexity                | 广度优先遍历   | breadth-first traversal     |
| 空间复杂度     | space complexity               | 深度优先遍历   | depth-first traversal       |
| 迭代           | iteration                      | 二叉搜索树     | binary search tree          |
| 递归           | recursion                      | 平衡二叉搜索树 | balanced binary search tree |
| 尾递归         | tail recursion                 | 平衡因子       | balance factor              |
| 递归树         | recursion tree                 | 堆             | heap                        |
| 大 $O$ 记号    | big-$O$ notation               | 大顶堆         | max heap                    |
| 渐近上界       | asymptotic upper bound         | 小顶堆         | min heap                    |
| 原码           | sign-magnitude                 | 优先队列       | priority queue              |
| 反码           | 1’s complement                 | 堆化           | heapify                     |
| 补码           | 2’s complement                 | Top-$k$ 问题   | Top-$k$ problem             |
| 数组           | array                          | 图             | graph                       |
| 索引           | index                          | 顶点           | vertex                      |
| 链表           | linked list                    | 无向图         | undirected graph            |
| 链表节点       | linked list node, list node    | 有向图         | directed graph              |
| 头节点         | head node                      | 连通图         | connected graph             |
| 尾节点         | tail node                      | 非连通图       | disconnected graph          |
| 列表           | list                           | 有权图         | weighted graph              |
| 动态数组       | dynamic array                  | 邻接           | adjacency                   |
| 硬盘           | hard disk                      | 路径           | path                        |
| 内存           | random-access memory (RAM)     | 入度           | in-degree                   |
| 缓存           | cache memory                   | 出度           | out-degree                  |
| 缓存未命中     | cache miss                     | 邻接矩阵       | adjacency matrix            |
| 缓存命中率     | cache hit rate                 | 邻接表         | adjacency list              |
| 栈             | stack                          | 广度优先搜索   | breadth-first search        |
| 栈顶           | top of the stack               | 深度优先搜索   | depth-first search          |
| 栈底           | bottom of the stack            | 二分查找       | binary search               |
| 队列           | queue                          | 搜索算法       | searching algorithm         |
| 双向队列       | double-ended queue             | 排序算法       | sorting algorithm           |
| 队首           | front of the queue             | 选择排序       | selection sort              |
| 队尾           | rear of the queue              | 冒泡排序       | bubble sort                 |
| 哈希表         | hash table                     | 插入排序       | insertion sort              |
| 桶             | bucket                         | 快速排序       | quick sort                  |
| 哈希函数       | hash function                  | 归并排序       | merge sort                  |
| 哈希冲突       | hash collision                 | 堆排序         | heap sort                   |
| 负载因子       | load factor                    | 桶排序         | bucket sort                 |
| 链式地址       | separate chaining              | 计数排序       | counting sort               |
| 开放寻址       | open addressing                | 基数排序       | radix sort                  |
| 线性探测       | linear probing                 | 分治           | divide and conquer          |
| 懒删除         | lazy deletion                  | 汉诺塔问题     | hanota problem              |
| 二叉树         | binary tree                    | 回溯算法       | backtracking algorithm      |
| 树节点         | tree node                      | 约束           | constraint                  |
| 左子节点       | left-child node                | 解             | solution                    |
| 右子节点       | right-child node               | 状态           | state                       |
| 父节点         | parent node                    | 剪枝           | pruning                     |
| 左子树         | left subtree                   | 全排列问题     | permutations problem        |
| 右子树         | right subtree                  | 子集和问题     | subset-sum problem          |
| 根节点         | root node                      | n 皇后问题     | n-queens problem            |
| 叶节点         | leaf node                      | 动态规划       | dynamic programming         |
| 边             | edge                           | 初始状态       | initial state               |
| 层             | level                          | 状态转移方程   | state-trasition equation    |
| 度             | degree                         | 背包问题       | knapsack problem            |
| 高度           | height                         | 编辑距离问题   | edit distance problem       |
| 深度           | depth                          | 贪心算法       | greedy algorithm            |
| 完美二叉树     | perfect binary tree            |                |                             |
| 完全二叉树     | complete binary tree           |                |                             |
| 完满二叉树     | full binary tree               |                |                             |
| 平衡二叉树     | balanced binary tree           |                |                             |

</div>
